# Copyright (C) 2009 Igor V. Burago

require 'optparse'

rand_seed = size = stage = nil
OptionParser.new do |p|
    p.on('-S', '--rand-seed R', Integer) { |x| rand_seed = x }
    p.on('-n', '--size N', Integer) { |x| size = x }
    p.on('-p', '--stage P', Float) { |x| stage = x }
end.parse!
fail 'invalid input' unless size && 1 <= size && stage && 0 <= stage && stage <= 1

srand(rand_seed || size + 2 ** 16 * stage)
last_line = 2 * (size - 1)
unused_lines = Array.new(2) { (0 .. last_line).to_a }

folds = [ ]
loop do
    count = unused_lines.first.size + unused_lines.last.size
    break if count == 0
    index, type = rand(count), 0
    unless index < unused_lines.first.size
        index -= unused_lines.first.size
        type = 1
    end

    list = unused_lines[type]
    line, subtype = list[index], 0
    (line < size ? 0 .. line - 1 : line + 1 .. last_line).each do |num|
        list.push(2 * line - num) if list.delete(num)
    end
    list.delete(line)

    unless line < size
        line = last_line - line
        subtype = 1
    end
    folds << "#{ '/\\'[type] }#{ 'ul'[subtype] }#{ line + 1 }"
end

folds_count = (stage * folds.size).round
puts "#{ size } #{ folds_count }", folds[0 ... folds_count].join
